Count Ways to Build Good Strings - Leetcode 2466 - Python

  Рет қаралды 8,755

NeetCodeIO

NeetCodeIO

Күн бұрын

Пікірлер
@rowanus116
@rowanus116 6 ай бұрын
regardless of previous string formulation as long as they have the same length, the decision is the same, either choose 0 or 1, that's why caches work here.
@anand.prasad502
@anand.prasad502 Жыл бұрын
3:18 Ans is "NO", it is length of string not the string, so it can be different. "000" and "100" result can be different;
@DavidDLee
@DavidDLee Жыл бұрын
If you go backwards in the iterative solution, the result is dp[0]. However, you can't just set dp[high] = 1 and keep everything else 0. Also, in the general case, max(dp[low:high + 1]) might be > 1.
@TheNishant30
@TheNishant30 Жыл бұрын
one of the test cases blows up the javascript stack even with memoization. low is 100000, high is 100000, zero is 2 and one is 8.
@ouchlock
@ouchlock Жыл бұрын
spent an hour with permutation approach, and it turned out to be so simple, muahh %(
@shubhaverma5697
@shubhaverma5697 4 ай бұрын
i think my mind broke when you went from backtracking to linked list lol
@uptwist2260
@uptwist2260 Жыл бұрын
thanks for the daily
@arpanbanerjee6224
@arpanbanerjee6224 Жыл бұрын
Great exoplanation as usual- java solution class Solution { Integer[] dp = null; int mod= 1000000007; private int helper(int low, int high, int zero, int one, int currLen){ if(currLen>high) return 0; if(dp[currLen]!=null) return dp[currLen]; int res=0; // if within range we wll include this string if(currLen>=low){ res=1; }else{ res=0; } res+= helper(low,high,zero,one,currLen+zero)%mod +helper(low,high,zero,one,currLen+one)%mod; dp[currLen]=res%mod; return dp[currLen]; } public int countGoodStrings(int low, int high, int zero, int one) { dp=new Integer[high+1]; return helper(low,high,zero,one,0); } }
@deadlyecho
@deadlyecho Жыл бұрын
Can we solve using a combinatorics approach ?
@ronbuchanan5432
@ronbuchanan5432 Жыл бұрын
What's the time complexity?
@heyitsmembermark
@heyitsmembermark Жыл бұрын
Bro is so emotional when explaining the problem.
@abaddon6206
@abaddon6206 Жыл бұрын
Can we do this problem using brute force and applying permutation and combination. Because in this problem all we have to find is the combination of the good string?
@kaushik.aryan04
@kaushik.aryan04 Жыл бұрын
This was a really good question
@krateskim4169
@krateskim4169 Жыл бұрын
Thank you so much
@aniketmahangare8333
@aniketmahangare8333 Жыл бұрын
Thank you so much man.
@MP-ny3ep
@MP-ny3ep Жыл бұрын
Thank you!
@sandeepmourya8922
@sandeepmourya8922 Жыл бұрын
Hey NeetCode or anyone reading this, I really need your help I cannot find single resource for good explanation of this problem: 2673. Make Costs of Paths Equal in a Binary Tree (It has no editorial on Leetcode) Everyone has almost used the same solution int minIncrements(int n, vector& cost) { int res = 0; function dfs = [&](int i) { if (i >= cost.size()) return 0; int a = dfs(2 * i + 1), b = dfs(2 * i + 2); res += abs(a - b); return cost[i] + max(a, b); }; dfs(0); return res; } But NOOOOO one explains clearly whyy do we have to return cost[i] + max(a, b). Any help from anyone in the comments section will be appreciated.
@kaushik.aryan04
@kaushik.aryan04 Жыл бұрын
You explained it really well but the code in python is very different when compared to java or c++ This is my code in java ( tabulation) class Solution { int mod = 1000000007; int[] dp ; public int countGoodStrings(int low, int high, int zero, int one) { dp = new int[high + Math.max(high , low) + 5]; // filling base case array for(int i = 0 ; i < high + 5 ; i++){ if(i >= low && i high) dp[i] = 0; } for(int i = high ; i >= 0 ; i--){ int left = dp[i+ zero] % mod; int right = dp[i + one] % mod; dp[i] = dp[i]+ (left+ right) % mod; } return dp[0]; } }
@mohdmaaz6651
@mohdmaaz6651 Жыл бұрын
Java Solution using HashMap: public int countGoodStrings(int low, int high, int zero, int one) { int mod = (int) 1e9+7; HashMap dp = new HashMap(); for(int i=high; i>=0; --i){ if(i>=low) dp.put(i, (1+dp.getOrDefault(i+zero, 0)+dp.getOrDefault(i+one, 0))%mod); else dp.put(i, (dp.getOrDefault(i+zero, 0)+dp.getOrDefault(i+one, 0))%mod); } return dp.get(0); }
@GameFlife
@GameFlife Жыл бұрын
bruh say feel good until tmr xDD
@amalvijay8222
@amalvijay8222 Жыл бұрын
1st comment and big fan
@name_surname_1337
@name_surname_1337 Жыл бұрын
do you know that fb doesn't ask DP at all? stop doing these fake thumbnails pls
Maximize Score after N Operations - Leetcode 1799 - Python
18:20
Увеличили моцареллу для @Lorenzo.bagnati
00:48
Кушать Хочу
Рет қаралды 8 МЛН
Кто круче, как думаешь?
00:44
МЯТНАЯ ФАНТА
Рет қаралды 5 МЛН
1, 2, 3, 4, 5, 6, 7, 8, 9 🙈⚽️
00:46
Celine Dept
Рет қаралды 111 МЛН
Молодой боец приземлил легенду!
01:02
МИНУС БАЛЛ
Рет қаралды 1,9 МЛН
Solving Questions With Brainpower - Leetcode 2140 - Python
14:48
Coding Unbreakable Encryption in C | One-Time Pad
17:42
HirschDaniel
Рет қаралды 4,3 М.
Dynamic Programming isn't too hard. You just don't know what it is.
22:31
DecodingIntuition
Рет қаралды 197 М.
Longest String Chain - Leetcode 1048 - Python
15:34
NeetCodeIO
Рет қаралды 10 М.
Please Master These 10 Python Functions…
22:17
Tech With Tim
Рет қаралды 215 М.
Maximum Matrix Sum - Leetcode 1975 - Python
16:07
NeetCodeIO
Рет қаралды 656
5 Useful F-String Tricks In Python
10:02
Indently
Рет қаралды 329 М.
Увеличили моцареллу для @Lorenzo.bagnati
00:48
Кушать Хочу
Рет қаралды 8 МЛН